#!/usr/bin/env python
#!coding: utf-8
import gtk
import locale
import gettext
from espeak import espeak
import os
import ConfigParser
import subprocess
import gettext
from gettext import gettext as _
gettext.textdomain('audiobook-converter')
voicelist=espeak.list_voices()
voicename=[]
voicefile=[]
for voice in voicelist:
    voicename.append(voice.name)
    voicefile.append(voice.identifier)
lang=os.getenv("LANG")[0:2]
class Preferences_Window(gtk.Builder):
    def read_preferences(self, filename):
        config = ConfigParser.ConfigParser()
        config.read(filename)
        self.get_object("output_format").set_active(int(config.get("general", "output_format")))
        self.get_object("bitrate_combo").set_active(int(config.get("general", "mp3_bitrate")))
        if config.get("general", "adding_ogg_title")=="True":
            self.get_object("adding_ogg_title").set_active(True)
        else:
            self.get_object("adding_ogg_title").set_active(False)
        language=config.get("speech", "reading_language")
        self.get_object("combobox1").set_active(voicename.index(language))
        self.get_object("adjustment1").set_value(float(config.get("speech", "speech_rate")))
        self.get_object("adjustment2").set_value(float(config.get("speech", "speech_pitch")))
        self.get_object("adjustment3").set_value(float(config.get("speech", "splitting_time")))
        if config.get("speech", "want_splitting")=="True":
            self.get_object("want_splitting").set_active(True)
        else:
            self.get_object("want_splitting").set_active(False)
        print self.get_object("want_splitting").get_active()

    def write_preferences(self, filename):
        config = ConfigParser.ConfigParser()
        try:
            config.add_section("general")
        except NoSectionError:
            pass
        config.set("general", "output_format", self.get_object("output_format").get_active())
        config.set("general", "mp3_bitrate", self.get_object("bitrate_combo").get_active())
        config.set("general", "adding_ogg_title", self.get_object("adding_ogg_title").get_active())
        try:
            config.add_section("speech")
        except NoSectionError:
            pass
        config.set("speech", "reading_language", self.get_object("combobox1").get_model()[self.get_object("combobox1").get_active()][0])
        config.set("speech", "speech_rate", int(self.get_object("speech_rate").get_value()))
        config.set("speech", "speech_pitch", int(self.get_object("speech_pitch").get_value()))
        config.set("speech", "want_splitting", self.get_object("want_splitting").get_active())
        config.set("speech", "splitting_time", int(self.get_object("splitting_time").get_value()))
        with open(filename, 'wb') as configfile:
            config.write(configfile)

    def toggle_splitting_time_slider(self, vidget):
        self.get_object("splitting_time_label").set_visible(vidget.get_active())
        self.get_object("splitting_time").set_visible(vidget.get_active())

    def __init__(self):
        gtk.Builder.__init__(self)
        self.set_translation_domain('audiobook-converter')
        self.add_from_file("preferences.ui")
        self.connect_signals(self)
        for d in voicename:
            self.get_object("combobox1").get_model().append([d])
        cell = gtk.CellRendererText()
        self.get_object("output_format").pack_start(cell, True)
        self.get_object("bitrate_combo").pack_start(cell, True)
        self.get_object("combobox1").pack_start(cell, True)
        self.get_object("output_format").add_attribute(cell, 'text',0)
        self.get_object("bitrate_combo").add_attribute(cell, 'text',0)
        self.get_object("combobox1").add_attribute(cell, 'text',0)
        if os.path.exists("audiobook_converter.conf"):
            self.read_preferences("audiobook_converter.conf")
        else:
            self.get_object("output_format").set_active(0)
            self.get_object("bitrate_combo").set_active(1)
            self.get_object("combobox1").set_active(voicefile.index(lang))
            self.get_object("adjustment1").set_value(230)
            self.get_object("adjustment2").set_value(30)
            self.get_object("adjustment3").set_value(60)

    def test(self, vidget):
        message=_("This is a testing message.")
        subprocess.call(
            ["espeak", "-v", voicefile[self.get_object("combobox1").get_active()], "-p",
             str(self.get_object("speech_pitch").get_value()), "-s",
             str(self.get_object("speech_rate").get_value()),
             message])

    def join_toggled(self, widget):
        if widget.get_active():
            print widget.get_label()
            widget.set_active(0)
    def output_format_changed(self, vidget):
        index=vidget.get_active()
        actual_format=vidget.get_model()[index][0]
        if actual_format=="Mp3":
            self.get_object("adding_ogg_title").set_visible(False)
            self.get_object("bitrate_combo").set_visible(True)
        else:
            self.get_object("adding_ogg_title").set_visible(True)
            self.get_object("bitrate_combo").set_visible(False)


    def toggle_splitting_time_presenting(self, vidget):
        pass

    def preferences(self, vidget):
        speech_dlg = speech_dialog.SpeechDialog()
        rate, pitch = speech_dlg.run()
        print rate,pitch

    def run(self):
        self.get_object("dialog1").show()
        answer=self.get_object("dialog1").run()
        print answer
        if answer==gtk.RESPONSE_OK:
            print "Clicked the Ok button."
            self.write_preferences("audiobook_converter.conf")
        else:
            print "You clicked cancel button, or closed the dialog."
        self.get_object("dialog1").destroy()


