import gtk
import audiobook_preferences
import gettext
from gettext import gettext as _
gettext.textdomain('audiobook-converter')

class MyWindow(gtk.Builder):
    def __init__(self):
        gtk.Builder.__init__(self)
        self.set_translation_domain('audiobook-converter')
        self.add_from_file("filechooser.ui")
        self.connect_signals(self)
        filter = gtk.FileFilter()
        filter.set_name(_("All supported formats"))
        filter.add_pattern("*.txt")
        filter.add_pattern("*.doc")
        filter.add_pattern("*.odt")
        filter.add_pattern("*.pdf")
        filter.add_pattern("*.htm")
        filter.add_pattern("*.html")
        self.get_object("filechooser1").add_filter(filter)
        filter = gtk.FileFilter()
        filter.set_name(_("Plain text files"))
        filter.add_pattern("*.txt")
        self.get_object("filechooser1").add_filter(filter)
        filter = gtk.FileFilter()
        filter.set_name(_("Word documents"))
        filter.add_pattern("*.doc")
        self.get_object("filechooser1").add_filter(filter)
        filter = gtk.FileFilter()
        filter.set_name(_("Pdf files"))
        filter.add_pattern("*.pdf")
        self.get_object("filechooser1").add_filter(filter)
        filter = gtk.FileFilter()
        filter.set_name("HTML files")
        filter.add_pattern("*.html *.htm")
        self.get_object("filechooser1").add_filter(filter)
        filter = gtk.FileFilter()
        filter = gtk.FileFilter()
        filter.set_name("Openoffice and Libreoffice documents")
        filter.add_pattern("*.odt")
        self.get_object("filechooser1").add_filter(filter)

    def changedir(self, widget):
       print self.get_object("filechooser1").get_filename()

    def run(self):
        answer=self.get_object("filechooser1").run()
        print answer
        filenames=self.get_object("filechooser1").get_filenames()
        for filename in filenames:
            print filename
        
    def quit(self, widget, data=None):
        """Signal handler for closing the AudiobookConverterWindow."""
        gtk.main_quit()

    def help(self, vidget):
        uri = "ghelp:audiobook-converter"
        gtk.show_uri(gtk.gdk.screen_get_default(),
                 uri,
                 gtk.get_current_event_time())

    def on_destroy(self, widget, data=None):
        """Called when the AudiobookConverterWindow is closed."""
        # Clean up code for saving application state should be added here.
        gtk.main_quit()

if __name__ == "__main__":
    mywindow = MyWindow()
    answer=mywindow.run()
    print answer
